#include <tigcclib.h>
#define VERSION 0
#define NOBS 30
#define NOPUPS 6
#define NOI 10
#define NOUNITS 5
enum keys {Eenter=13,Eback=257,Eclear=263,Eescape,Eapps,Emode,Ef1=268,Ef2,Ef3,Ef4,Ef5,Ef6,Ef7,Ef8,Ehome=277,Ecatalog,Eup=337,Eleft,Eleftup,Edown,Eupdown,Eleftdown,Eleftupdown,Eright,Eupright,Eleftright,Eleftupright,Erightdown,Euprightdown,Eleftdownright,Euprightleftdown,E2nddimondalpha,Edimondalpha=380,E2nddimondshiftalpha=384,E2ndescape=4360,E2ndhome=4373,E2ndup=4433,E2ndleft,E2ndleftup,E2nddown,E2ndupdown,E2ndleftdown,E2ndrightupdown,E2ndright,E2ndupright,E2ndleftright,E2ndleftupright,E2ndrightdown,E2nduprightdown,E2ndleftdownright,E2nduprightleftdown,Edimondenter=16397,Edimondback=16641,Edimondclear=16647,Edimondescape,Edimondapps,Edimondmode,Edimondup=16721,Edimondleft,Edimondleftup,Edimonddown,Edimondupdown,Edimondleftdown,Edimondrightupdown,Edimondright,Edimondupright,Edimondleftright,Edimondleftupright,Edimondrightdown,Edimonduprightdown,Edimondleftdownright,Edimonduprightleftdown};
enum ptypes {Emoney,Ejump,Ejetpack,Ekillpill,Eteleport};
enum ftypes {Eavhs,Eavesave};
enum units {Epixels,Efeet,Erealfeet,Erealinches,Escreens};
INT_HANDLER oldint5=NULL;
volatile unsigned char count,tick,ticks; // tick for general timing, and ticks for block droping
volatile short tickers; // tickers for lava advancement
DEFINE_INT_HANDLER (myint5handler) {
    ExecuteHandler(oldint5);
	if (count) {
		tick++;
		ticks++;
		tickers++;
	}
}
typedef struct {
	char pos;
	char vy;
	long height;
	unsigned char inUse;
	unsigned char size;
} block;
typedef struct {
	char ax;
	char ay;
	char vx;
	char vy;
	long height;
	short pos;
	unsigned char inair;
	unsigned char lives;
	unsigned long pups[NOPUPS];
} person;
typedef struct {
	char vy;
	long height;
	unsigned char inuse;
	unsigned char pos;
	unsigned char type;
} powerup;
block blocks[NOBS];
person you;
powerup pup;
char fname[18];
unsigned long SDbig[]={0x3fffffc0,0x7ffffde0,0xffffff30,0xfffffe30,0xfffffff0,0xffffff90,0xffffffd0,0xfffffff0,0xffe07ff0,0xffc03ff0,0xff801ff0,0xff001ff0,0xff000ff0,0xff000ff0,0xff000ff0,0xff000ff0,0xff001ff0,0xff801ff0,0xffc03ff0,0xffe07ff0,0xfffffff0,0xfffffff0,0xfffffff0,0xfffffff0,0xfffffff0,0xfffffff0,0x7fffffe0,0x3fffffc0};
unsigned long SLbig[]={0x3fffffc0,0x40000020,0x80000010,0x80000010,0x80000010,0x80000010,0x80204010,0x819f9810,0x81a05810,0x82402010,0x80801410,0x81001010,0x81000810,0x81000810,0x81000810,0x81000810,0x81001410,0x82801010,0x80403810,0x81a05810,0xc19fa010,0x80200010,0xc0000010,0xa0000010,0xb4000010,0xb0000010,0x45000020,0x3fffffc0};
unsigned short SDsmall[]={0x3ffc,0x7fee,0xfff3,0xfff3,0xffff,0xfe7d,0xfc3f,0xf81f,0xf81f,0xfc3f,0xfe7f,0xffff,0xffff,0xffff,0x7ffe,0x3ffc};
unsigned short SLsmall[]={0x3ffc,0x4002,0x8001,0x8801,0x8981,0xa661,0x8421,0x8811,0x8811,0x8429,0xc679,0x8199,0xa041,0xb001,0x4802,0x3ffc};
unsigned char Syou[]={0x7e,0x81,0x81,0x81,0x81,0x81,0x81,0x81,0x81,0x81,0x7e};
unsigned char jetpack[]={0x18,0x18,0x3c,0xe7,0xa5,0xbd,0x18,0x24};
unsigned char jump[]={0x10,0x38,0x7c,0xfe,0x38,0x38,0x38,0x38};
unsigned char money[]={0x00,0x10,0x3c,0x50,0x38,0x14,0x78,0x10};
unsigned char lock[]={0x18,0x24,0x24,0x7e,0x42,0x5a,0x4a,0x7e};
unsigned char killpill[]={0x00,0x00,0x7e,0xf1,0xf1,0x7e,0x00,0x00};
unsigned char title[]={0x80,0xf6,0xf6,0x80,0x00,0x00,0xce,0x82,0xba,0x92,0x92,0xfe,0xfe,0x82,0x82,0x00,0x00,0x82,0x82,0xfe,0xfe,0x92,0x10,0x92,0xfe,0xfe,0x82,0x82,0x00,0xe8,0x24,0xc2,0x82,0x82,0x46,0x3c,0x18,0x00,0x80,0x80,0xfe,0x8c,0x18,0x30,0x60,0xc2,0xfe,0x82,0x82,0x00,0x02,0x06,0x1e,0x7a,0xc8,0x3a,0x0a,0x06,0x02,0x00,0x00,0x0e,0x02,0x02,0x82,0x82,0xfe,0xfe,0x82,0x82,0x00,0x02,0x06,0x1e,0x7a,0xc8,0x3a,0x0a,0x06,0x02,0x00,0x80,0xc0,0xb0,0x08,0x0e,0xb8,0xf0,0xc0,0x80,0x00,0x02,0x06,0x1e,0x7a,0xc8,0x3a,0x0a,0x06,0x02};
unsigned char teleport[]={0xff,0x89,0x89,0xf9,0x9f,0x91,0x91,0xff};
unsigned char classic,cunit,combo[2],drop[NOPUPS+1],egame,flash,hitground,invest[2],jspeed,jtime,level,onblock,onside,poweractive,ptime,t;
unsigned short snum;
double pixtounit(long px);
long lavah,camh,bestheight,unittopix(double unit);
void disp(),dispsb(void *ds,void *ls,unsigned char hidden),endcombo(),esave(),find(unsigned char what),*gs,pause(),play(),respawn(),save(),startBlock(unsigned char b),store(),tp();
void _main(void) { // startup screen
	FILE *f1;
	short i;
	unsigned short t;
	if (!(gs=malloc(GRAYDBUFFER_SIZE))||!GrayOn()) // make sure that there's enough room on the calc for the double buffering engine and grayscale
		goto end; // if not, exit the program
	GrayDBufInit(gs); // initalize the double buffering engine
	tick=ticks=tickers=count=0; // initalize counter variables before we turn on the counter
	oldint5=GetIntVec(AUTO_INT_5); // store the old interrupt handler
	SetIntVec(AUTO_INT_5,myint5handler); // put my own in
	randomize(); // seed the random number generator so you don't get the same numbers when the program is archived
	cunit=Efeet; // sets the units to feet
	classic=1;
	egame=0;

	find(Eavhs);
	if (fname[0]) { // if the high score file exists
		f1=fopen("avhs","rb");
		fgetc(f1);
		fread(&snum,2,1,f1); // extract the serial number
		fclose(f1);
	}
	else // if not...
		snum=rand(); // make a new one
	find(Eavesave);
	if (fname[0]) { // if there was a saved game already in progress
		f1=fopen(fname,"rb");
		fread(&t,2,1,f1); // get the serial number
		if (t!=snum) { // if it doesn't match the current serial number, the user either deleted the high score file while a game was saved, or cheated by saving the game by renaming the save game file
			fclose(f1);
			remove(fname);
			GrayDBufSetActiveAMSPlane(LIGHT_PLANE);
			clrscr();
			printf("Sorry, you can only play agame that has just been\nsaved");
			GrayDBufSetActiveAMSPlane(DARK_PLANE);
			clrscr();
			printf("Sorry, you can only play agame that has just been\nsaved");
			ngetchx();
		}
		else { // if the searial numbers match, load the game
			tick=fgetc(f1);
			ticks=fgetc(f1);
			fread(&t,2,1,f1);
			tickers=t;
			fread(&lavah,4,1,f1);
			fread(&camh,4,1,f1);
			fread(&bestheight,4,1,f1);
			fread(&combo,1,2,f1);
			fread(&drop,1,NOPUPS,f1);
			fread(&invest,1,2,f1);
			classic=fgetc(f1);
			jspeed=fgetc(f1);
			level=fgetc(f1);
			onblock=fgetc(f1);
			onside=fgetc(f1);
			poweractive=fgetc(f1);
			ptime=fgetc(f1);
			hitground=fgetc(f1);
			cunit=fgetc(f1);
			jtime=fgetc(f1);
			fread(&you,sizeof(person),1,f1);
			fread(&blocks,sizeof(block),NOBS,f1);
			fread(&pup,sizeof(powerup),1,f1);
			fclose(f1);
			remove(fname);
			egame=1;
			FontSetSys(F_8x10);
			play();
			if (egame)
				goto end;
		}
	}

	while (1) {
		GrayDBufSetActiveAMSPlane(LIGHT_PLANE); // set to light plane
		clrscr(); // clear it
		GrayDBufSetActiveAMSPlane(DARK_PLANE); // set to dark plane
		ScrRectFill(&(SCR_RECT){{0,0,159,99}},&(SCR_RECT){{0,0,159,99}},A_NORMAL); // fill it
		FontSetSys(F_8x10); // Set font to HUGE font
		DrawStr(36,5,"Avalanche 2",A_REVERSE);
		DrawStr(10,60,"Classic",A_REVERSE);
		DrawStr(78,60,"Adventure",A_REVERSE);
		FontSetSys(F_6x8);
		DrawStr(17,18,"Marshmallow's Revenge",A_REVERSE);
		i=0;
		while (i!=Eenter) {
			if (classic) {
				DrawLine(10,71,66,71,A_REVERSE);
				DrawLine(78,71,151,71,A_NORMAL);
			}
			else {
				DrawLine(10,71,66,71,A_NORMAL);
				DrawLine(78,71,151,71,A_REVERSE);
			}
			do i=ngetchx();while (i!=Eleft&&i!=Eright&&i!=Eenter&&i!=Eescape);
			switch (i) {
				case Eright:
				case Eleft:classic=!classic;break;
				case Eenter:play();if (egame)goto end;break;
				case Eescape:goto end;break;
			}
		}
	}

	end:;
	GrayOff(); // turn off grayscale and the double buffering engine
	SetIntVec(AUTO_INT_5,oldint5); // restore the old interrupt handler
	if (gs)
		free(gs); // free the allocated memory for the grayscale planes
	// see ya later
}
double pixtounit(long px) { // converts pixels to cunit
	switch (cunit) {
		case Epixels:return (double)px;break;
		case Efeet:return (double)px*7/15;break;
		case Erealfeet:return (double)px*.001128;break;
		case Erealinches:return (double)px*.013533;break;
		case Escreens:return (double)px/100;break;
	}
	return 0;
}
long unittopix(double unit) { // converts unit cunits to pixels
	switch (cunit) {
		case Epixels:return unit;break;
		case Efeet:return unit*15/7;break;
		case Erealfeet:return unit/.0011458333333333;break;
		case Erealinches:return unit/.01375;break;
		case Escreens:return unit*100;break;
	}
	return 0;
}
void disp() { // displays the main screen
	unsigned char a,*ps=NULL;
	void *ds,*ls;
	ds=GrayDBufGetHiddenPlane(DARK_PLANE);
	ls=GrayDBufGetHiddenPlane(LIGHT_PLANE);
	GrayDBufSetHiddenAMSPlane(LIGHT_PLANE);
	ClrScr();
	GrayDBufSetHiddenAMSPlane(DARK_PLANE);
	ClrScr();
	if (cunit==Epixels||cunit==Efeet) {	
		printf_xy(119,0,"%.0f",pixtounit(bestheight));
		printf_xy(119,10,"%.0f",pixtounit(you.height));
	}
	else {
		printf_xy(119,0,"%#.2f",pixtounit(bestheight));
		printf_xy(119,10,"%#.2f",pixtounit(you.height));
	}
	if (!classic)
		printf_xy(12,0,"$%.02f",(float)you.pups[0]);
	if (flash&&ticks>19*3) { // times up in the flashing...
		flash=0;
		ticks=t;
		you.ay=-1;
		you.inair=1;
	}
	if (!classic&&combo[0]>1)
		printf_xy(44,89,"COMBO! %d",combo[0]);
	if (pup.inuse) {
		if (pup.height<camh&&pup.height+8>camh) { // the power up is halfway off of the top of the screen
			switch (pup.type) {
				case Emoney:ps=money;break;
				case Ejump:ps=jump;break;
				case Ejetpack:ps=jetpack;break;
			}
			Sprite8(pup.pos,0,camh-pup.height,ps+8-(camh-pup.height),ds,SPRT_XOR);
			Sprite8(pup.pos,0,camh-pup.height,ps+8-(camh-pup.height),ls,SPRT_XOR);
		}
		else if (pup.height+8<=camh&&pup.height+8>camh-100) { // if the block is totally on the screen
			switch (pup.type) {
				case Emoney:ps=money;break;
				case Ejump:ps=jump;break;
				case Ejetpack:ps=jetpack;break;
			}
			Sprite8(pup.pos,camh-pup.height-8,8,ps,ds,SPRT_XOR);
			Sprite8(pup.pos,camh-pup.height-8,8,ps,ls,SPRT_XOR);
		}
	}
	for (a=0;a<NOBS;a++) {
		if (!blocks[a].inUse) // skips unused blocks
			continue;
		if (blocks[a].height<camh&&blocks[a].height+blocks[a].size>camh) { // if the block is helfway off of the top of the screen
			if (blocks[a].size==16) {
				Sprite16(blocks[a].pos,0,camh-blocks[a].height,SDsmall+16-(camh-blocks[a].height),ds,SPRT_XOR);
				Sprite16(blocks[a].pos,0,camh-blocks[a].height,SLsmall+16-(camh-blocks[a].height),ls,SPRT_XOR);
			}
			if (blocks[a].size==28) {
				Sprite32(blocks[a].pos,0,camh-blocks[a].height,SDbig+28-(camh-blocks[a].height),ds,SPRT_XOR);
				Sprite32(blocks[a].pos,0,camh-blocks[a].height,SLbig+28-(camh-blocks[a].height),ls,SPRT_XOR);
			}
		}
		else if (blocks[a].height+blocks[a].size<=camh&&blocks[a].height+blocks[a].size>camh-100) { // if the block is totally visible on the screen (minus the bottom edge)
			if (blocks[a].size==16) {
				Sprite16(blocks[a].pos,camh-blocks[a].height-16,16,SDsmall,ds,SPRT_XOR);
				Sprite16(blocks[a].pos,camh-blocks[a].height-16,16,SLsmall,ls,SPRT_XOR);
			}
			if (blocks[a].size==28) {
				Sprite32(blocks[a].pos,camh-blocks[a].height-28,28,SDbig,ds,SPRT_XOR);
				Sprite32(blocks[a].pos,camh-blocks[a].height-28,28,SLbig,ls,SPRT_XOR);
			}
		}
	}
	if (!flash||(flash&&(ticks/10)%2)) {
		Sprite8(you.pos,camh-you.height-11,11,Syou,ds,SPRT_XOR);
		Sprite8(you.pos,camh-you.height-11,11,Syou,ls,SPRT_XOR);
	}
	if (camh-lavah<99) {
		GrayDBufSetHiddenAMSPlane(DARK_PLANE);
		ScrRectFill(&(SCR_RECT){{11,camh-lavah,159,99}},&(SCR_RECT){{0,0,159,99}},A_NORMAL);
		GrayDBufSetHiddenAMSPlane(LIGHT_PLANE);
		ScrRectFill(&(SCR_RECT){{11,camh-lavah,159,99}},&(SCR_RECT){{0,0,159,99}},A_REVERSE);
	}
	if (camh<100) {
		GrayDBufSetHiddenAMSPlane(DARK_PLANE);
		ScrRectFill(&(SCR_RECT){{11,camh,159,99}},&(SCR_RECT){{0,0,159,99}},A_NORMAL);
		GrayDBufSetHiddenAMSPlane(LIGHT_PLANE);
		ScrRectFill(&(SCR_RECT){{11,camh,159,99}},&(SCR_RECT){{0,0,159,99}},A_NORMAL);
	}
	dispsb(ls,ds,1);
	GrayDBufToggle();
}
void dispsb(void *ds,void *ls,unsigned char hidden) { // displays the side bar in ls and ds
	if (hidden)
		GrayDBufSetHiddenAMSPlane(LIGHT_PLANE);
	else
		GrayDBufSetActiveAMSPlane(LIGHT_PLANE);
	ScrRectFill(&(SCR_RECT){{0,0,11,99}},&(SCR_RECT){{0,0,159,99}},A_REVERSE);
	DrawLine(11,0,11,99,A_NORMAL);
	if (hidden)
		GrayDBufSetHiddenAMSPlane(DARK_PLANE);
	else
		GrayDBufSetActiveAMSPlane(DARK_PLANE);
	ScrRectFill(&(SCR_RECT){{0,0,11,99}},&(SCR_RECT){{0,0,159,99}},A_REVERSE);
	DrawLine(11,0,11,99,A_NORMAL);
	FontSetSys(F_6x8);
	if (classic) {
		Sprite8(0,0,100,title,ds,SPRT_XOR);
		Sprite8(0,0,100,title,ls,SPRT_XOR);
	}
	else {
		Sprite8(1,1,11,Syou,ds,SPRT_XOR);
		Sprite8(1,1,11,Syou,ls,SPRT_XOR);
		printf_xy(2,13,"%d",you.lives);
		if (level>=2) {
			Sprite8(1,25,8,jump,ds,SPRT_XOR);
			Sprite8(1,25,8,jump,ls,SPRT_XOR);
			printf_xy(1,34,"%ld",you.pups[Ejump]);
			Sprite8(1,44,8,killpill,ds,SPRT_XOR);
			Sprite8(1,44,8,killpill,ls,SPRT_XOR);
			printf_xy(1,53,"%ld",you.pups[Ekillpill]);
		}
		if (level>=3) {
			Sprite8(1,63,8,jetpack,ds,SPRT_XOR);
			Sprite8(1,63,8,jetpack,ls,SPRT_XOR);
			printf_xy(2,72,"%ld",you.pups[Ejetpack]);
		}
		if (level>=10) {
			Sprite8(1,82,8,teleport,ds,SPRT_XOR);
			Sprite8(1,82,8,teleport,ls,SPRT_XOR);
			printf_xy(2,91,"%ld",you.pups[Eteleport]);
		}
	}
	if (poweractive) { // a powerup is active
		if (tick>ptime) { // if the time is up,
			switch (poweractive) {
				case Ejump:jspeed=10; // return jumping to normal
				default:poweractive=0;break;
			}
		}
		else
			ScrRectFill(&(SCR_RECT){{0,99*((float)tick/ptime),10,99}},&(SCR_RECT){{0,0,159,99}},A_NORMAL);
	}
	FontSetSys(F_8x10);
}
void endcombo() { // finishes a combo
	unsigned char a;
	unsigned long b;
	if (combo[0]==1) {
		combo[0]=0;
		return;
	}
	b=1;
	if (combo[0]>20)
		combo[0]=20;
	for (a=2;a<combo[0];a++)
		b*=2;
	you.pups[0]+=b;
	combo[0]=0;
}
void esave() { // saves the game in a file
	unsigned short t;
	FILE *f1;
	find(Eavesave);
	if (!fname[0])
		sprintf(fname,"avesave");
	f1=fopen(fname,"wb");
	fwrite(&snum,2,1,f1);
	fputc(tick,f1);
	fputc(ticks,f1);
	t=tickers;
	fwrite(&t,2,1,f1);
	fwrite(&lavah,4,1,f1);
	fwrite(&camh,4,1,f1);
	fwrite(&bestheight,4,1,f1);
	fwrite(&combo,1,2,f1);
	fwrite(&drop,1,NOPUPS,f1);
	fwrite(&invest,1,2,f1);
	fputc(classic,f1);
	fputc(jspeed,f1);
	fputc(level,f1);
	fputc(onblock,f1);
	fputc(onside,f1);
	fputc(poweractive,f1);
	fputc(ptime,f1);
	fputc(hitground,f1);
	fputc(cunit,f1);
	fputc(jtime,f1);
	fwrite(&you,sizeof(person),1,f1);
	fwrite(&blocks,sizeof(block),NOBS,f1);
	fwrite(&pup,sizeof(powerup),1,f1);
	fputc(0,f1);
	fputs("Save",f1);
	fputc(0,f1);
	fputc(OTH_TAG,f1);
	fclose(f1);
	save();
}
void find(unsigned char what) { // finds what on the calculator and stores the name into fname, if it can't be found, fname[0]=0
	SYM_ENTRY *SymPtr;
	SymPtr=SymFindFirst(NULL,FO_RECURSE);
	fname[0]=0;
	while (SymPtr) {
		switch (what) {
			case Eavhs:
				if (!strcmp(SymPtr->name,"avhs")) {
					FolderGetCur(fname);
					if (strcmp(SymFindFolderName(),fname))
						sprintf(fname,"%s\\avhs",SymFindFolderName());
					else
						sprintf(fname,"avhs");
					return;
				}
				break;
			case Eavesave:
				if (!strcmp(SymPtr->name,"avesave")) {
					FolderGetCur(fname);
					if (strcmp(SymFindFolderName(),fname))
						sprintf(fname,"%s\\avesave",SymFindFolderName());
					else
						sprintf(fname,"avesave");
					return;
				}
				break;
		}
		SymPtr=SymFindNext();
	}
}
void pause() { // displays the pause screen
	short k;
	count=0; // this turns off the counting
	k=0;
	while (k!=Ehome&&k!='2') {
		GrayDBufSetActiveAMSPlane(LIGHT_PLANE);
		ClrScr();
		GrayDBufSetActiveAMSPlane(DARK_PLANE);
		ScrRectFill(&(SCR_RECT){{0,0,159,99}},&(SCR_RECT){{0,0,159,99}},A_NORMAL);
		FontSetSys(F_8x10);
		DrawStr(60,5,"Pause",A_REVERSE);
		FontSetSys(F_6x8);
		DrawStr(15,20,"1 - Units:",A_REVERSE);
		switch (cunit) {
			case Epixels:DrawStr(81,20,"pixels",A_REVERSE);break;
			case Efeet:DrawStr(81,20,"feet",A_REVERSE);break;
			case Erealfeet:DrawStr(81,20,"real feet",A_REVERSE);break;
			case Erealinches:DrawStr(81,20,"real inches",A_REVERSE);break;
			case Escreens:DrawStr(81,20,"screens",A_REVERSE);break;
		}
		DrawStr(15,30,"2 - Resume",A_REVERSE);
		DrawStr(15,40,"3 - Pause to home screen",A_REVERSE);
		k=ngetchx();
		switch (k) {
			case '3':
			case Eescape:
				egame=1;
				esave();
				return;
				break;
			case '1':
				if (++cunit==NOUNITS)
					cunit=0;
				break;
		}
	}
	count=1; // turns counting back on

}
void play() { // Plays a game
	unsigned char a,b,c,r,l;
	short i=0;
	snum=rand(); // generate a new serial number for the game
	if (egame) { // if a game has been loaded and the settings set
		egame=0;
		goto mid;
	}
	for (a=0;a<NOBS;a++)
		blocks[a].inUse=0; // initalize the blocks
	for (a=0;a<NOPUPS;a++) {
		you.pups[a]=0; // initialize the powerups
		drop[a]=0; // initialize the drop array
	}
	poweractive=0; // no powerups are active
	FontSetSys(F_8x10); // set the font to huge
	if (classic) // if in clasic mode, you only have 1 life
		you.lives=1;
	else // where as in adventure mode, you start with 3
		you.lives=3;
	you.pos=76; // put you in the middle of the screen
	you.height=45; // put you in the air
	bestheight=45; // initalize the best height;
	jspeed=10; // initialize the jump speed (ie jump height)
	you.ax=0;
	you.ay=-1;
	you.vx=0;
	you.vy=0; // initialize the velocities and accelerations
	you.inair=1; // lets the calc know that you are in the air
	level=1; // start you off at level 1
	pup.inuse=0; // make sure the power up is off
	lavah=-120; // set the lava height to 120 below so you have time to go up before the lava does
	camh=80; // initialize the camera height
	onblock=255; // if you are on a block, onblock is the number of the block you're on, else it's 255
	flash=0; // flash is set to 1 when you die and are placed back on top
	invest[0]=0; // initialize the investment variable
	combo[0]=0; // initialize the combo thingy
	count=1; // this makes tick, ticks, and tickers go up every int5 cycle
	hitground=1; // so you can use a jetpack...
	jtime=2;
	while (1) { // gameplay
		do disp();while (flash); // display the screen
		if (tickers>=5) { // so the lava advances once every 5 interrupt cycles
			lavah++;
			tickers=0;
		}
		if (ticks>20) { // every 20 interrupt cycles, a block or powerup falls
			ticks=0; // reset ticks
			if (!classic&&pup.inuse==0&&rand()%5==0) { // if it's in adventure mode, the powerup isn't in use, and a 1 in 5 chance
				pup.inuse=1; // turn on the powerup
				pup.height=500+bestheight; // start it 500 heigher than your best height
				pup.pos=rand()%140+11; // put it somewhere on the screen
				pup.vy=-2; // make it drop
				pup.type=Emoney;
				if (drop[0]>0&&rand()%5==0) // 1 in 5 chance
					pup.type=drop[rand()%drop[0]+1];
			}
			else { // else just drop another block
				for (a=0;a<NOBS;a++) {
					if (blocks[a].inUse) // skips blocks in use
						continue;
					startBlock(a); // starts the first unused block
					break;
				}
			}
		}
		if (you.height<lavah) { // you've fallen into lava
			disp(); // display the screen so you see you're in lava
			if (you.lives>1) { // if you have a life to spear
				you.lives--; // take away a life
				respawn(); // put you back up top
			}
			else // if you don't have a life to spear
				goto end;
		}
		for (a=0;a<NOBS;a++) {
			if (!blocks[a].inUse) // skip the block if it's not in use
				continue;
			blocks[a].height+=blocks[a].vy; // move the block
			if (blocks[a].height+blocks[a].size<lavah-25) { // if the block is way under lava
				blocks[a].inUse=0; // deactivate it, free it to be put back up top
				continue;
			}
			if (blocks[a].vy==0) // proceed if the block has landed
				continue;
			for (b=0;b<NOBS;b++) {
				if (b==a||!blocks[b].inUse) // skip unused blocks and itself
					continue;
				if (blocks[a].pos+blocks[a].size>blocks[b].pos&&blocks[a].pos<blocks[b].pos+blocks[b].size) { // this block is next to another block
					if (blocks[a].height<blocks[b].height+blocks[b].size&&blocks[a].height+blocks[a].size>blocks[b].height) { // the block has hit another block
						blocks[a].height=blocks[b].height+blocks[b].size; // set the block ontop of the other block
						blocks[a].vy=blocks[b].vy;
					}
				}
			}
			if (blocks[a].height<0) { // if the block has hit the floor
				blocks[a].height=0; // set the block on the floor
				blocks[a].vy=0; // stop the block
			}
			if (onblock==a&&blocks[a].vy>=you.vy) { // if you are on this block
				you.height=blocks[a].height+blocks[a].size; // bring you down with the block
				if (blocks[a].vy==0&&combo[0])
					endcombo();
			}
			if ((onside&127)==a) { // if you are on the side of this block
				if (blocks[a].vy==0&&combo[0])
					endcombo();
			}
		}
		if (kbhit()) { // if a key was hit
			i=ngetchx(); // store the key into i
			switch (i) {
				case Ehome: // if home was hit
				case E2ndhome:
					mid:;
					pause();
					if (egame)
						goto end;
					break;
				case Eescape: // if they hit escape
				case E2ndescape:
					goto end;
					break;
				case Ef1: // activate powerup - reset tick; set poweractive; set ptime
				case Ef6:
					if (you.pups[Ejump]>0) { // if you have a jump
						tick=0; // reset tick
						jspeed=15; // make you jump HIGH
						you.pups[Ejump]--; // get rid of a jump
						poweractive=Ejump; // set the active powerup to jump
						ptime=19*10; // give you 10 seconds of jumping time
					}
					break;
				case Ef2:
				case Ef7:
					if (you.pups[Ekillpill]>0) { // if you have a jump
						tick=0; // reset tick
						jspeed=10; // reset your jumping ability
						you.pups[Ekillpill]--; // get rid of a killpill
						if (you.lives>1) {
							you.lives--;
							respawn();
						}
						else
							goto end;
					}
					break;
				case Ef3:
				case Ef8:
					if (you.pups[Ejetpack]>0&&hitground) { // if you have a jetpack
						hitground=0; // this is to make it so you have to hit a block or the ground before you use another jetpack
						tick=0; // reset tick
						jspeed=10; // reset your jumping ability
						you.pups[Ejetpack]--; // take away one of your jetpacks
						poweractive=Ejetpack; // set the active power up to jetpack
						ptime=19*jtime; // give you jtime seconds of jet-packing
					}
					break;
				case Ef4:
					if (you.pups[Eteleport]>0) {
						you.pups[Eteleport]--;
						tp();
					}
			}
		}
		a=b=c=0; // set a b and c to 0
		BEGIN_KEYTEST // start an optimised keytest block
			r=_keytest_optimized(RR_RIGHT); // if right is being pressed
			l=_keytest_optimized(RR_LEFT); // if left is being pressed
			c=_keytest_optimized(RR_2ND); // if second is being pressed
		END_KEYTEST // end the optimesed keytest block
		you.ax=0;// stop your left-right movement;
		if (r&&!l) { // if right is pressed, but not left
			if (you.vx<5) // if you're going slower than 5 px/f then speed up
				you.ax=1;
			if (onside<255) { // if you're on the side of a block
				if (onside&128) { // if you're on the right side of a block
					onside=255; // turn off onside
					you.ay=-1; // reset you're y accelleration
				}
			}
		}
		if (l&&!r) { // if left is pressed, but not right
			if (you.vx>-5)
				you.ax=-1;
			if (onside<255) {
				if (!onside&128) {
					onside=255;
					you.ay=-1;
				}
			}
		}
		if (r==l) { // if both right and left are pressed, or not pressed
			if (you.vx<0)
				you.vx++;
			if (you.vx>0)
				you.vx--;
			if (onside<255) {
				onside=255;
				you.ay=-1;
			}
		}
		if (c&&(!you.inair||onside<255||poweractive==Ejetpack)) { // if you hit 2nd and you're on the ground, wall, or you have a jetpack
			if (onside<255) {
				if (onside&128)
					you.vx=5;
				else
					you.vx=-5;
				onside=255;
			}
			you.inair=1;
			you.ay=-1;
			you.vy=jspeed;
			onblock=255;
		}
		you.vx+=you.ax;
		you.vy+=you.ay;
		if (you.vy<-10)
			you.vy=-10;
		you.pos+=you.vx;
		if (you.pos<0)
			you.pos+=160;
		else if (you.pos>159)
			you.pos-=160;
		you.height+=you.vy;
		if (you.height>bestheight)
			bestheight=you.height;
		if (you.height<0) { // you've hit the ground
			hitground=1;
			you.height=0;
			you.ay=0;
			you.vy=0;
			you.inair=0;
			if (combo[0])
				endcombo();
		}
		if (pup.inuse) {
			pup.height+=pup.vy;
			if (pup.height<=0) {
				pup.height=0;
				pup.vy=0;
			}
			if (lavah>pup.height+8)
				pup.inuse=0;
		}
		if (onblock<255) { // if you're on a block
			if (you.pos+7<blocks[onblock].pos||you.pos>blocks[onblock].pos+blocks[onblock].size) { // if you're not on a block (ie. fallen off)
				onblock=255;
				you.inair=1;
				you.ay=-1;
			}
		}
		for (a=0;a<NOBS;a++) { // checks for block colisions
			if (!blocks[a].inUse)
				continue;
			if (pup.inuse) {
				if (pup.pos+8>blocks[a].pos&&pup.pos<blocks[a].pos+blocks[a].size&&pup.height<blocks[a].height+blocks[a].size&&pup.height+8>blocks[a].height) {
					pup.height=blocks[a].height+blocks[a].size;
					if (pup.vy==-2)
						pup.vy=0;
					else // it has been crushed by a block
						pup.inuse=0;
				}
				if (pup.pos+8>you.pos&&pup.pos<you.pos+8&&pup.height<you.height+11&&pup.height+8>you.height) { // you got the power up
					if (pup.type==Emoney||you.pups[pup.type]<9) {
						switch (pup.type) {
							case Emoney:
								if (you.inair&&pup.vy<0) {
									if (combo[0]>=2)
										you.pups[0]+=50*combo[0];
									else
										you.pups[0]+=100;
								}
								else
									you.pups[0]+=50;
								break;
							case Ejump:you.pups[Ejump]++;break;
							case Ejetpack:you.pups[Ejetpack]++;break;
						}
					}
					pup.inuse=0;
				}
			}
			if (you.height+10>=blocks[a].height&&you.height<blocks[a].height+blocks[a].size) { // you are next to the block
				if (you.pos+7>=blocks[a].pos&&you.pos<blocks[a].pos+blocks[a].size) { // you have colided with the block
					hitground=1;
					if (you.inair) {
						if (you.vx>0) { // if you're moving to the right
							i=(float)you.height-((float)you.vy)/((float)you.vx)*((float)you.pos+8-blocks[a].pos);
							if (i+11>=blocks[a].height&&i<=blocks[a].height+blocks[a].size) { // using b=y-mx   you've hit the side
								you.vx=0;
								you.ax=0;
								you.pos=blocks[a].pos-8;
								if (r&&!l) { // if right is pressed
									onside=a;
									you.ay=0;
									you.vy=-1;
									if (combo[0]) {
										if (blocks[a].vy<0) {
											if (combo[1]!=a) {
												combo[0]++;
												combo[1]=a;
											}
										}
										else
											endcombo();
									}
									else if (blocks[a].vy<0) {
										combo[0]=1;
										combo[1]=a;
									}
								}
							}
							else if (i+11<blocks[a].height) { // You've hit the bottom of the block
								you.vy=0;
								you.height=blocks[a].height-13;
							}
							else if (i>blocks[a].height+blocks[a].size) { // You've landed on the thing
								you.height=blocks[a].height+blocks[a].size;
								you.inair=0;
								you.vy=0;
								you.ay=0;
								onblock=a;
								onside=255;
								if (combo[0]) {
									if (blocks[a].vy<0) {
										if (combo[1]!=a) {
											combo[0]++;
											combo[1]=a;
										}
									}
									else
										endcombo();
								}
								else if (blocks[a].vy<0) {
									combo[0]=1;
									combo[1]=a;
								}
							}
						}
						else if (you.vx<0) { // if you're moving to the left
							i=(float)you.height-((float)you.vy)/((float)you.vx)*((float)you.pos-(blocks[a].pos+blocks[a].size));
							if (i+11>=blocks[a].height&&i<=blocks[a].height+blocks[a].size) { // using b=y-mx   you've hit the side
								you.vx=0;
								you.ax=0;
								you.pos=blocks[a].pos+blocks[a].size;
								if (!r&&l) { // if left is pressed
									onside=a;
									onside|=128;
									you.ay=0;
									you.vy=-1;
									if (combo[0]) {
										if (blocks[a].vy<0) {
											if (combo[1]!=a) {
												combo[0]++;
												combo[1]=a;
											}
										}
										else
											endcombo();
									}
									else if (blocks[a].vy<0) {
										combo[0]=1;
										combo[1]=a;
									}
								}
							}
							else if (i+11<blocks[a].height) { // You've hit the bottom of the block
								you.vy=0;
								you.height=blocks[a].height-12;
							}
							else if (i>blocks[a].height+blocks[a].size) { // You've landed on the thing
								you.height=blocks[a].height+blocks[a].size;
								you.inair=0;
								you.vy=0;
								you.ay=0;
								onblock=a;
								onside=255;
								if (combo[0]) {
									if (blocks[a].vy<0) {
										if (combo[1]!=a) {
											combo[0]++;
											combo[1]=a;
										}
									}
									else
										endcombo();
								}
								else if (blocks[a].vy<0) {
									combo[0]=1;
									combo[1]=a;
								}
							}
						}
						else {
							if (you.vy>0||you.height<blocks[a].height) { // you've hit the bottom
								you.vy=0;
								you.height=blocks[a].height-12;
							}
							else if (you.vy<0) { // You've landed on it
								onblock=a;
								you.inair=0;
								you.vy=0;
								you.ay=0;
								you.height=blocks[a].height+blocks[a].size;
								onside=255;
								if (combo[0]) {
									if (blocks[a].vy<0) {
										if (combo[1]!=a) {
											combo[0]++;
											combo[1]=a;
										}
									}
									else
										endcombo();
								}
								else if (blocks[a].vy<0) {
									combo[0]=1;
									combo[1]=a;
								}
							}
						}
					}
					else {
						if (blocks[a].vy<0&&blocks[a].height>you.height+8) // you've been squished
							if (you.lives>1) {
								you.lives--;
								respawn();
							}
							else
								goto end;
						else if (you.vx>0)
							you.pos=blocks[a].pos-8;
						else
							you.pos=blocks[a].pos+blocks[a].size;
						you.vx=0;
						you.ax=0;
					}
				}
			}
		}
		camh=you.height+50;
		if (camh<70)
			camh=70;
		if (!classic&&bestheight>=level*500) {
			level++;
			store();
		}
	}
	end:;
	if (!egame) {
		GrayDBufSetActiveAMSPlane(LIGHT_PLANE);
		clrscr();
		if (cunit==Epixels||cunit==Efeet)
			printf("Your score was %.0f",pixtounit(bestheight));
		else
			printf("Your score was %#.2f",pixtounit(bestheight));
		GrayDBufSetActiveAMSPlane(DARK_PLANE);
		clrscr();
		if (cunit==Epixels||cunit==Efeet)
			printf("Your score was %.0f",pixtounit(bestheight));
		else
			printf("Your score was %#.2f",pixtounit(bestheight));
		ngetchx();
		save();
	}
}
void respawn() { // puts you back up top
	unsigned char a,b;
	you.height=bestheight; // put you back up to your heighest height
	ticks=0; // reset ticks
	flash=1; // turn on flashing
	t=ticks;
	you.vx=0;
	you.vy=0;
	you.ax=0;
	you.ay=0; // reset your movement
	you.inair=1;
	combo[0]=0;
	for (b=0;b<160;b++) {
		for (a=0;a<NOBS;a++) {
			if (!blocks[a].inUse)
				continue;
			if (you.height+10>=blocks[a].height&&you.height<blocks[a].height+blocks[a].size&&you.pos+7>=blocks[a].pos&&you.pos<blocks[a].pos+blocks[a].size) {
				you.pos++;
				if (you.pos>159)
					you.pos=0;
			}
			else
				return;
		}
	}
}
void startBlock(unsigned char b) { // starts block b up top
	blocks[b].inUse=1;
	blocks[b].size=16+12*(rand()%2);
	blocks[b].pos=rand()%(159-blocks[b].size);
	blocks[b].height=bestheight+200;
	if (classic)
		blocks[b].vy=-2;
	else	
		blocks[b].vy=-(2+(level>5)+(level>10)+(level>15)-(level>5&&rand()%2));
}
void save() { // saves the highscore file, while checking for a high score
	FILE *f1=NULL;
	char name[2][10];
	short score[2],k;
	unsigned char a,version;
	name[0][0]=0;
	name[1][0]=0;
	score[0]=0;
	score[1]=0;
	version=0;
	GrayDBufSetActiveAMSPlane(LIGHT_PLANE);
	ScrRectFill(&(SCR_RECT){{0,0,159,99}},&(SCR_RECT){{0,0,159,99}},A_NORMAL);
	GrayDBufSetActiveAMSPlane(DARK_PLANE);
	clrscr();
	find(Eavhs);
	if (fname[0]) {
		EM_moveSymFromExtMem(SYMSTR(fname),HS_NULL);
		f1=fopen(fname,"rb");
		version=fgetc(f1);
		fread(&score[0],2,1,f1);
		if (version!=VERSION) {
			fclose(f1);
			printf("The high score filewas probably saved using a future\nversion of\nAvelanche. The\nscores in this fileare unreadable.");
			ngetchx();
			clrscr();
			printf("F1 - Clear old\n     scores and\n     save file in\n     this version\n\nF2 - Skip saving\n     and leave file\n     untouched");
			do k=ngetchx();while (k<Ef1||k>Ef2);
			if (k==Ef2) {
				EM_moveSymToExtMem(SYMSTR(fname),HS_NULL);
				return;
			}
			score[0]=0;
			score[1]=0;
			clrscr();
		}
		else {
			a=0;
			do {
				name[0][a]=fgetc(f1);
				a++;
			} while (name[0][a-1]!=0);
			fread(&score[0],2,1,f1);
			a=0;
			do {
				name[1][a]=fgetc(f1);
				a++;
			} while (name[1][a-1]!=0);
			fread(&score[1],2,1,f1);
			fclose(f1);
		}
	}
	else {
		score[0]=0;
		score[1]=0;
	}
	if (!egame) {
		if (bestheight>score[classic]) {
			printf("High Score!\nEnter your name\n");
			getsn(name[classic],10);
			score[classic]=bestheight;
		}
		clrscr();
		printf("High Score:\n\n%s\n",name[classic]);
		if (cunit==Epixels||cunit==Efeet)
			printf("%.0f ",pixtounit(score[classic]));
		else
			printf("%#.2f ",pixtounit(score[classic]));
		switch (cunit) {
			case Epixels:printf("pixels");break;
			case Efeet:printf("feet");break;
			case Erealfeet:printf("real feet");break;
			case Erealinches:printf("real inches");break;
			case Escreens:printf("screens");break;
		}
		ngetchx();
	}
	if (!fname[0])
		sprintf(fname,"avhs");
	f1=fopen(fname,"wb");
	fputc(VERSION,f1);
	fwrite(&snum,2,1,f1);
	for (a=0;a<=strlen(name[0]);a++)
		fputc(name[0][a],f1);
	fwrite(&score[0],2,1,f1);
	for (a=0;a<=strlen(name[1]);a++)
		fputc(name[1][a],f1);
	fwrite(&score[1],2,1,f1);
	fputc(0,f1);
	fputc('A',f1);
	fputc('v',f1);
	fputc('H',f1);
	fputc('S',f1);
	fputc(0,f1);
	fputc(OTH_TAG,f1);
	fclose(f1);
	EM_moveSymToExtMem(SYMSTR(fname),HS_NULL);
}
void store() { // shows the store
	char moneystr[13];
	short k;
	unsigned a,p,y;
	void *ds,*ls;
	count=0; // this turns off counting
	switch (invest[0]) {
		case 1:
			if (level-invest[1]>=3) {
				invest[0]=0;
				you.pups[0]+=1000;
			}
			break;
		case 2:
			if (level-invest[1]>=4) {
				invest[0]=0;
				you.pups[0]+=2250;
			}
	}
	ds=GrayDBufGetActivePlane(DARK_PLANE);
	ls=GrayDBufGetActivePlane(LIGHT_PLANE);
	GrayDBufSetActiveAMSPlane(LIGHT_PLANE);
	ClrScr();
	GrayDBufSetActiveAMSPlane(DARK_PLANE);
	ScrRectFill(&(SCR_RECT){{12,0,159,99}},&(SCR_RECT){{0,0,159,99}},A_NORMAL);
	FontSetSys(F_8x10);
	DrawStr(65,2,"Store",A_REVERSE);
	y=0; // y is the shift of the list
	p=0; // p is the position of the cursor in the list
	while (1) {
		FontSetSys(F_6x8);
		ScrRectFill(&(SCR_RECT){{23,16,31,86}},&(SCR_RECT){{0,0,159,99}},A_NORMAL);
		for (a=0;a<7;a++) {
			switch (a+y) {
				case 0:
					Sprite8(23,16+10*a,11,Syou,ds,SPRT_XOR);
					DrawStr(35,20+10*a,"Extra life     $2000",A_REVERSE);
					break;
				case 1:
					Sprite8(23,19+10*a,8,jump,ds,SPRT_XOR);
					DrawStr(35,20+10*a,"High jump      $75  ",A_REVERSE);
					break;
				case 2:
					Sprite8(23,19+10*a,8,killpill,ds,SPRT_XOR);
					DrawStr(35,20+10*a,"Kill pill      $25  ",A_REVERSE);
					break;
				case 3:
					if (level>=3) {
						Sprite8(23,19+10*a,8,jetpack,ds,SPRT_XOR);
						DrawStr(35,20+10*a,"Jet pack       $200 ",A_REVERSE);
					}
					else {
						Sprite8(23,19+10*a,8,lock,ds,SPRT_XOR);
						DrawStr(35,20+10*a,"Get at least 1000 px",A_REVERSE);
					}
					break;
				case 4:
					if (level>=5) {
						Sprite8(23,19+10*a,8,jump,ds,SPRT_XOR);
						DrawStr(35,20+10*a,"Free high jumps$700 ",A_REVERSE);
					}
					else {
						Sprite8(23,19+10*a,8,lock,ds,SPRT_XOR);
						DrawStr(35,20+10*a,"Get at least 2000 px",A_REVERSE);
					}
					break;
				case 5:
					if (level>=5) {
						Sprite8(23,19+10*a,8,jetpack,ds,SPRT_XOR);
						DrawStr(35,20+10*a,"Free jet packs $700 ",A_REVERSE);
					}
					else {
						Sprite8(23,19+10*a,8,lock,ds,SPRT_XOR);
						DrawStr(35,20+10*a,"Get at least 2000 px",A_REVERSE);
					}
					break;
				case 6:
					if (level>=7) {
						Sprite8(23,19+10*a,8,jetpack,ds,SPRT_XOR);
						DrawStr(35,20+10*a,"4 sec Jet Pack $1000",A_REVERSE);
					}
					else {
						Sprite8(23,19+10*a,8,lock,ds,SPRT_XOR);
						DrawStr(35,20+10*a,"Get at least 3000 px",A_REVERSE);
					}
					break;
				case 7:
					if (level>=10) {
						Sprite8(23,19+10*a,8,teleport,ds,SPRT_XOR);
						DrawStr(35,20+10*a,"Teleport       $1500",A_REVERSE);
					}
					else {
						Sprite8(23,19+10*a,8,lock,ds,SPRT_XOR);
						DrawStr(35,20+10*a,"Get at least 4500 px",A_REVERSE);
					}
					break;
				case 8:
					Sprite8(23,19+10*a,8,money,ds,SPRT_XOR);
					DrawStr(35,20+10*a,"Invst $500@200% in 3",A_REVERSE);
					break;
				case 9:
					Sprite8(23,19+10*a,8,money,ds,SPRT_XOR);
					DrawStr(35,20+10*a,"Invst $900@250% in 4",A_REVERSE);
					break;
			}
		}
		DrawChar(12,6,32-13*(y>0),A_REVERSE);
		DrawChar(12,89,32-12*(y<NOI-7),A_REVERSE);
		dispsb(ls,ds,0);
		FontSetSys(F_8x10);
		sprintf(moneystr,"$%ld",you.pups[0]);
		DrawStr(104,1,"       ",A_REVERSE);
		DrawStr(160-strlen(moneystr)*8,1,moneystr,A_REVERSE);
		ScrRectFill(&(SCR_RECT){{12,20,20,20+70}},&(SCR_RECT){{0,0,159,99}},A_NORMAL);
		DrawChar(12,20+10*p,18,A_REVERSE);
		k=ngetchx();
		switch (k) {
			case Eescape:count=1;return;break;
			case Eenter:
				switch (p+y) {
					case 0:
						if (you.pups[0]>=2000&&you.lives<9) {
							you.pups[0]-=2000;
							you.lives++;
						}
						break;
					case 1:
						if (you.pups[0]>=75&&you.pups[Ejump]<9) {
							you.pups[0]-=75;
							you.pups[Ejump]++;
						}
						break;
					case 2:
						if (you.pups[0]>=25&&you.pups[Ekillpill]<9) {
							you.pups[0]-=25;
							you.pups[Ekillpill]++;
						}
						break;
					case 3:
						if (level>=3&&you.pups[0]>=200&&you.pups[Ejetpack]<9) {
							you.pups[0]-=200;
							you.pups[Ejetpack]++;
						}
						break;
					case 4:
						if (level>=5&&you.pups[0]>=700) {
							for (a=1;a<(unsigned char)(1+drop[0]);a++) {
								if (drop[a]==Ejump)
									break;
							}
							if (a==(unsigned char)(drop[0]+1)) {
								you.pups[0]-=700;
								drop[drop[0]+1]=Ejump;
								drop[0]++;
							}
						}
						break;
					case 5:
						if (level>=5&&you.pups[0]>=700) {
							for (a=1;a<(unsigned char)(1+drop[0]);a++) {
								if (drop[a]==Ejetpack)
									break;
							}
							if (a==(unsigned char)(drop[0]+1)) {
								you.pups[0]-=700;
								drop[drop[0]+1]=Ejetpack;
								drop[0]++;
							}
						}
						break;
					case 6:
						if (level>=7&&you.pups[0]>=1000&&jtime<4) {
							you.pups[0]-=1000;
							jtime=4;
						}
						break;
					case 7:
						if (level>=10&&you.pups[0]>=1500&&you.pups[Eteleport]<9) {
							you.pups[0]-=1500;
							you.pups[Eteleport]++;
						}
						break;
					case 8:
						if (!invest[0]&&you.pups[0]>=500) {
							you.pups[0]-=500;
							invest[0]=1;
							invest[1]=level;
						}
						break;
					case 9:
						if (!invest[0]&&you.pups[0]>=900) {
							you.pups[0]-=900;
							invest[0]=2;
							invest[1]=level;
						}
						break;
				}
				break;
			case Eup:
				if (p==0) {
					if (y==0) {
						p=6;
						y=NOI-7;
					}
					else
						y--;
				}
				else
					p--;
				break;
			case Edown:
				p++;
				if (p==7) {
					p=6;
					y++;
					if (y>NOI-7) {
						p=0;
						y=0;
					}
				}
				break;
		}
	}
}
void tp() { // teleport - lets the user move the marshmellow where they want
	unsigned char d,e,l,r,s,u;
	you.inair=1;
	you.vx=0;
	you.vy=0;
	you.ax=0;
	you.ay=-1;
	while (1) {
		camh=you.height+50;
		if (camh<70)
			camh=70;
		disp();
		BEGIN_KEYTEST // start an optimised keytest block
			r=_keytest_optimized(RR_RIGHT); // if right is being pressed
			l=_keytest_optimized(RR_LEFT); // if left is being pressed
			u=_keytest_optimized(RR_UP); // if up is being pressed
			d=_keytest_optimized(RR_DOWN); // if down is being pressed
			s=_keytest_optimized(RR_2ND); // if second is being pressed
			e=_keytest_optimized(RR_ENTER); // if enter is being pressed
		END_KEYTEST // end the optimesed keytest block
		if (r) {
			if (s) {
				you.pos+=10;
				if (you.pos>159)
					you.pos-=150;
			}
			else {
				you.pos++;
				if (you.pos>159)
					you.pos=0;
			}
		}
		if (l) {
			if (s) {
				if (you.pos<10)
					you.pos+=160;
				you.pos-=10;
			}
			else {
				if (you.pos==0)
					you.pos=160;
				you.pos--;
			}
		}
		if (u) {
			if (s) {
				if (you.height<bestheight-10)
					you.height+=10;
			}
			else {
				if (you.height<bestheight)
					you.height++;
			}
		}
		if (d) {
			if (s) {
				if (you.height>lavah+11)
					you.height-=10;
			}
			else {
				if (you.height>lavah+1)
					you.height--;
			}
		}
		if (e) {
			if (kbhit())
				ngetchx();
			return;
		}
	}
}
